=== debian/changelog ===
ott (0.32+ds-3) unstable; urgency=medium

  * Change b-dep from libcoq-ocaml-dev to libcoq-core-ocaml-dev.

 -- Julien Puydt <jpuydt@debian.org>  Wed, 25 Jan 2023 09:49:04 +0100

ott (0.32+ds-2) unstable; urgency=medium

  * Complete d/copyright.
  * Add patch to fix typos.

 -- Julien Puydt <jpuydt@debian.org>  Sun, 10 Jul 2022 18:17:48 +0200

ott (0.32+ds-1) unstable; urgency=medium

  * Initial release. (Closes: #1014610)

 -- Julien Puydt <jpuydt@debian.org>  Fri, 08 Jul 2022 20:48:48 +0200
