=== debian/control ===
Source: ott
Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
Uploaders: Julien Puydt <jpuydt@debian.org>
Section: ocaml
Priority: optional
Standards-Version: 4.6.1
Rules-Requires-Root: no
Build-Depends: coq,
               debhelper-compat (= 13),
               dh-coq,
               dh-ocaml,
               help2man,
               hevea,
               libcoq-core-ocaml-dev,
               libcoq-stdlib,
               libocamlgraph-ocaml-dev,
               pandoc
Vcs-Browser: https://salsa.debian.org/ocaml-team/ott
Vcs-Git: https://salsa.debian.org/ocaml-team/ott.git
Homepage: https://github.com/ott-lang/ott

Package: libcoq-ott
Architecture: any
Depends: ${coq:Depends}, ${misc:Depends}
Provides: ${coq:Provides}
Description: Ott tool (Coq plugin)
 Ott is a tool to write definitions of programming
 languages and calculi. From the definition of a
 language syntex and semanticsin a concise and readable
 notation close to informal mathematics, it can
 provide LaTeX, Coq, HOL, Isabelle/HOL, Lem or OCaml
 versions of the definition.
 .
 Coq is a proof assistant for higher-order logic.
 .
 This package provides the Coq plugin itself.

Package: ott-tools
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Ott tool (executable)
 Ott is a tool to write definitions of programming
 languages and calculi. From the definition of a
 language syntex and semanticsin a concise and readable
 notation close to informal mathematics, it can
 provide LaTeX, Coq, HOL, Isabelle/HOL, Lem or OCaml
 versions of the definition.
 .
 Coq is a proof assistant for higher-order logic.
 .
 This package provides the executable.
