=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/ocaml/ocamlvars.mk

%:
	dh $@ --with coq,ocaml

override_dh_auto_clean:
	# doesn't work

override_dh_auto_build:
	make -C coq
	make -C src
	make -C doc top2.html
	help2man -N src/ott > debian/ott.1

override_dh_auto_install:
	DESTDIR=$(CURDIR)/debian/tmp make -C coq install
	DESTDIR=$(CURDIR)/debian/tmp make -C src install
