=== debian/changelog ===
ott (0.33+ds-2build3) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 16:11:24 +1100

ott (0.33+ds-2build2) noble; urgency=medium

  * No-change rebuild for new libcoq-stdlib ABI

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 24 Mar 2024 00:16:17 +0000

ott (0.33+ds-2build1) noble; urgency=medium

  * Rebuild against latest coq

 -- Jeremy Bícha <jbicha@ubuntu.com>  Fri, 22 Dec 2023 21:05:57 -0500

ott (0.33+ds-2) unstable; urgency=medium

  * Fix d/rules clean target (Closes: #1049273).

 -- Julien Puydt <jpuydt@debian.org>  Thu, 21 Dec 2023 16:34:16 +0100

ott (0.33+ds-1) unstable; urgency=medium

  * New upstream release.
  * Refresh packaging.

 -- Julien Puydt <jpuydt@debian.org>  Mon, 12 Jun 2023 19:35:45 +0200
