=== hol/Makefile ===
all:
	Holmake

clean:
	rm -f *Theory.* *.ui *.uo
	rm -rf .HOLMK .hollogs
